package org.apache.bcel.verifier;

import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang3.ArrayUtils;

public abstract class PassVerifier {
   private final List<String> messages = new ArrayList();
   private VerificationResult verificationResult;

   public void addMessage(String message) {
      this.messages.add(message);
   }

   public abstract VerificationResult do_verify();

   public String[] getMessages() {
      return (String[])this.getMessagesList().toArray(ArrayUtils.EMPTY_STRING_ARRAY);
   }

   public List<String> getMessagesList() {
      this.verify();
      return this.messages;
   }

   public VerificationResult verify() {
      if (this.verificationResult == null) {
         this.verificationResult = this.do_verify();
      }

      return this.verificationResult;
   }
}
